dnl ######################################################################
dnl
dnl File:	babel.m4
dnl
dnl Purpose:	Determine where the babel files are.
dnl
dnl Version:	$Id: babel.m4,v 1.1 2005/02/27 16:48:28 cary Exp $
dnl
dnl Copyright Tech-X Corporation, 2001.  Redistribution allowed provided
dnl this copyright statement remains intact.
dnl
dnl ######################################################################

dnl ######################################################################
dnl
dnl Determine the location of babel
dnl
dnl ######################################################################


AC_ARG_WITH(babel,
[  --with-babel=<babel compiler>     to set absolute path of babel compiler], 
BABEL="$withval")

# For now, just look.  Need to fix this up later
if test -z "$BABEL"; then

# Look if known directories
  BABEL_PATH=$PATH:/usr/local/babel/bin
  AC_PATH_PROGS(BABEL, babel, , $BABEL_PATH)

fi

if test -z "$BABEL"; then
  AC_MSG_ERROR(Unable to find babel in $BABEL_PATH.  Use --with-babel to set absolute path the babel.)
else
  AC_SUBST(BABEL)
  BABEL_BINDIR=`dirname $BABEL`
  BABEL_INCDIR=`dirname $BABEL_BINDIR`/include
  AC_SUBST(BABEL_INCDIR)
fi

dnl ######################################################################
dnl
dnl Now should set fortran compilers as set in babel
dnl
dnl ######################################################################

dnl not yet implemented.

