#!/bin/sh
######################################################################
#
# File:		cleanconf.sh
#
# Purpose:	to remove autogenerated files
#
# Version:	$Id: cleanconf.sh,v 1.10 2005/07/13 14:00:48 cary Exp $
#
# Copyright 2003, Tech-X Corporation
#
######################################################################

# read command-line parameters
while getopts a opt; do
  case "$opt" in
    a)
      regenconf=true
      ;;
    \?) # unknown flag
      echo >&2 "Usage: $0 [-a]"
      exit 1
      ;;
  esac
done
shift `expr $OPTIND - 1`

# Get rid of old files
echo Removing all the autogenerated files
cmd='rm -f configure config.cache aclocal.m4 config.h.in'
echo "$cmd"
eval $cmd

rmfiles="Makefile.in Makefile.am.orig hdrs.txt cppsrcs.txt cxxsrcs.txt distfiles.txt"
for i in $rmfiles; do
   # cmd='find ./ -name hdrs.txt -exec rm -f {} \;'
  cmd="find ./ -name $i -exec "'rm -f {} \;'
  echo $cmd
  eval $cmd
done


echo Removing configure cache
cmd="rm -rf autom4te.cache autom4te-*.cache"
echo "$cmd"
eval $cmd

# Creating new files for this platform
if test -z "$regenconf"; then
  echo
  echo You should now make files specific to local versions of
  echo automake/autoconf by doing the following:
  echo config/regenconf.sh
  echo or run this with the -a option
else
  configdir=`dirname $0`
  echo $configdir/regenconf.sh
  $configdir/regenconf.sh
fi

