dnl ######################################################################
dnl
dnl Check for Python stuff
dnl
dnl ######################################################################

dnl Find location of python

AC_ARG_WITH(PY_ROOT,
[  --with-PY_ROOT=<python install root>     to set root for python installation],
PY_ROOT="$withval")
if test -n "$PY_ROOT"; then
  PY_PATH=$PY_ROOT/bin
else
  PY_PATH=$PATH:$HOME/$host/python/bin:/mfe/local/python/bin:/loc/python/bin
fi
AC_PATH_PROGS(PYTHON, python, "", $PY_PATH)
if test -n "$PYTHON"; then
  PYTHON_BINDIR=`dirname $PYTHON`
  PY_ROOT=`dirname $PYTHON_BINDIR`
else
  AC_MSG_WARN(Unable to find python in your path.  Python Makefile\'s will not be created.)
  PYTHON_MAKEFILES=""
fi
AC_SUBST(PYTHON_BINDIR)
AC_SUBST(PYTHON)

dnl ######################################################################
dnl
dnl Find the python include files
dnl
dnl ######################################################################

AC_MSG_CHECKING(for python includes)
PYTHON_SITEDIR=`python -c "import sys, site; print site.sitedirs[[0]]"`
AC_SUBST(PYTHON_SITEDIR)
PYTHON_TOPLIBDIR=`dirname $PYTHON_SITEDIR`
PYTHON_INCDIR=`echo $PYTHON_TOPLIBDIR | sed 's/lib/include/'`
AC_SUBST(PYTHON_INCDIR)
AC_MSG_RESULT(-I$PYTHON_INCDIR)
PYTHON_TOPDIR=`dirname $PYTHON_TOPLIBDIR`
PYTHON_TOPDIR=`dirname $PYTHON_TOPDIR`
# echo Python is in $PYTHON_TOPDIR

dnl ######################################################################
dnl
dnl Find the python libraries
dnl
dnl ######################################################################

AC_MSG_CHECKING(for python library)
PYTHON_LIBDIR=$PYTHON_TOPLIBDIR/config
AC_SUBST(PYTHON_LIBDIR)
PY_VERSION=`python -c "import sys; print sys.version[[:3]]"`
PYTHON_LIB="python"$PY_VERSION
AC_SUBST(PYTHON_LIB)
AC_MSG_RESULT(-L$PYTHON_LIBDIR -l$PYTHON_LIB)

dnl ######################################################################
dnl
dnl Add in the python site libraries to allow tailoring of the build
dnl
dnl ######################################################################

if test "$SITE" = "llnl.gov"; then
  PY_SITE_LIBS="-Wl,-R,/opt/SUNWspro/lib -L/opt/SUNWspro/lib -lF77 -lM77 -lsunmath -L/mfe/local/Yorick/yorick-1.4/Gist -lgist -L/mfe/local/lib -R/mfe/local/lib -ltk8.3 -ltcl8.3 -Wl,-R,/usr/openwin/lib -L/usr/openwin/lib -lX11 -lpthread  -L/usr/ccs/lib -lgen"
fi
AC_SUBST(PY_SITE_LIBS)

