//-----------------------------------------------------------------------
//
// File:	oops.cpp
//
// Purpose:	Simple exception containing a string
//
// Version: $Id: oops.cpp,v 1.3 2004/09/08 03:37:15 yew Exp $
//
// Copyright (c) 1999 by Tech-X Corporation.  All rights reserved.
//
//-----------------------------------------------------------------------

// txbase includes
#include <oops.h>

// default constructor
Oops::Oops() {
}

// constructor taking a string
Oops::Oops(const TXSTD::string& str) {
  msg = str;
}

// Copy constructor
Oops::Oops(const Oops& d) {
  msg = d.msg;
}

// Destructor: virtual -- All resources released implicitly
Oops::~Oops() {
}

// Assignment
Oops& Oops::operator=(const Oops& d) {
  if( this == &d ) return *this;
  msg = d.msg;
  return *this;
}

//
Oops& Oops::operator<<(TXSTD::string str) {
  msg +=  str;
  return *this;
}

void Oops::prepend(const TXSTD::string &s){
  TXSTD::string st = s;
  msg = st + msg; 
}
